import { Plugin } from 'rollup';
import { ObfuscationResult, ObfuscatorOptions } from 'javascript-obfuscator';
type FilterOptions = string | RegExp | (string | RegExp)[];
export interface RollupPluginObfuscatorOptions {
    /**
     * Set to `true` if you want to obfuscate the whole bundle, `false` to obfuscate each file separately.
     * @default false
     */
    global: boolean;
    /**
     * javascript-obfuscator options. Refer to documentation here https://github.com/javascript-obfuscator/javascript-obfuscator#javascript-obfuscator-options
     * @default {}
     */
    options: ObfuscatorOptions;
    /**
     * Files to include when applying per-file obfuscation.
     * @default ['**\/*.js', '**\/*.ts']
     */
    include: FilterOptions;
    /**
     * Files to exclude when applying per-file obfuscation. The priority is higher than `include`.
     * @default ['node_modules/**']
     */
    exclude: FilterOptions;
    /**
     * Overwrite the obfuscate method used.
     */
    obfuscate: (sourceCode: string, inputOptions?: ObfuscatorOptions) => ObfuscationResult;
}
declare function rollupPluginObfuscator(override?: Partial<RollupPluginObfuscatorOptions>): Plugin;
export default rollupPluginObfuscator;
//# sourceMappingURL=rollup-plugin-obfuscator.d.ts.map